package com.hamaf.hikyakucms.sample.schedule.process;

import java.util.Calendar;
import com.hamaf.hikyakucms.sample.schedule.access.HatsubanAccess;
import com.hamaf.hikyakucms.sample.schedule.access.ScheduleAccess;
import com.hamaf.hikyakucms.sample.schedule.access.V_ScheduleAccess;
import com.hamaf.hikyakucms.sample.schedule.access.HatsubanAccess.HATSUBAN_KBN;
import com.hamaf.hikyakucms.sample.schedule.dto.ScheduleCountDto;
import com.hamaf.hikyakucms.sample.schedule.dto.ScheduleDto;
import com.hamaf.hikyakucms.sample.schedule.dto.ScheduleSearchDto;
import com.hamaf.hikyakucms.sample.schedule.dto.VScheduleDto;
import com.hamaf.hikyakucms.sample.schedule.dto.VScheduleSearchDto;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface.COMMFLD;
import com.hamaf.hikyaku.security.SecurityCheckUtils;
import com.hamaf.hikyaku.security.dto.UserDto;
import com.hamaf.hikyaku.util.DateUtil;

/**
 * <p>^CgFScheduleProcess is .</p>
 * <p>FXPW[֌W̏sB</p>
 * <br>XPW[e[ǔE擾EXV@\
 *
 * <p>쌠: Copyright (c) 2010/07/12</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class ScheduleProcess {

  private ScheduleAccess _sa;
  private V_ScheduleAccess _vsa;
  private HatsubanAccess _ha;

  /**
   *  Creates a new <code>ScheduleProcess.java</code> instance.
   * <br>Default Constructor
   */
  public ScheduleProcess() {
    _sa = new ScheduleAccess();
    _vsa = new V_ScheduleAccess();
    _ha = new HatsubanAccess();
//    _vsa.setDebug();
  }

  /**
   * Describe <code>find</code> method : .
   * <br>XPW[̌B
   *
   * @param ssd a <code>ScheduleSearchDto</code> :
   * @return a <code>ScheduleSearchDto</code> :
   * @throws Exception
   */
  public ScheduleSearchDto find(ScheduleSearchDto ssd) throws Exception {
    return (ScheduleSearchDto)_sa.find(ssd);
  }
  public ScheduleCountDto find (ScheduleCountDto scd) throws Exception {
  	return (ScheduleCountDto)_sa.find(scd);
  }
  public VScheduleSearchDto find(VScheduleSearchDto ssd) throws Exception {
    return (VScheduleSearchDto)_vsa.find(ssd);
  }

  /**
   * Describe <code>findbyprimarykey</code> method : .
   * <br>XPW[̏ڍ׎擾B
   *
   * @param sd a <code>ScheduleDto</code> :
   * @return a <code>ScheduleDto</code> :
   * @throws Exception
   */
  public ScheduleDto findbyprimarykey(ScheduleDto sd) throws Exception {
    return (ScheduleDto)_sa.findByPrimaryKey(sd);
  }

  /**
   * Describe <code>findviewbykey</code> method : .
   * <br>XPW[r[L[ڂŏڍׂ擾B
   *
   * @param vsd a <code>VScheduleDto</code> :
   * @param uid a <code>String</code> : v҂̃[U[ID
   * @return a <code>VScheduleDto</code> :
   * @throws Exception
   */
  public VScheduleDto findviewbykey(VScheduleDto vsd, String uid) throws Exception {
    vsd.clearRequest(VScheduleDto.UPUNAME);
  	vsd = (VScheduleDto)_vsa.findByPrimaryKey(vsd);
    SecurityCheckUtils scu = new SecurityCheckUtils();
    UserDto ud = scu.getUserInf(vsd.getCommFld(COMMFLD.UUSR), uid);
    vsd.setItemValue(VScheduleDto.UPUNAME, ud.getItemValue(UserDto.NAME));
    return vsd;
  }

  /**
   * Describe <code>register</code> method : .
   * <br>XPW[̓o^B
   *
   * @param sd a <code>ScheduleDto</code> :
   * @throws Exception
   */
  public void register(ScheduleDto sd) throws Exception {
    sd.setItemValue(ScheduleDto.SEQNO,
    		_ha.getNextNo(HATSUBAN_KBN.SCHEDULE, sd.getItemValue(ScheduleDto.USER_ID), sd.getSysId()));
    _sa.regist(sd);
  }

  /**
   * Describe <code>update</code> method : .
   * <br>XPW[̍XVB
   *
   * @param sd a <code>ScheduleDto</code> :
   * @throws Exception
   */
  public void update(ScheduleDto sd) throws Exception {
    _sa.update(sd);
  }

  /**
   * Describe <code>delete</code> method : .
   * <br>XPW[̍폜B
   *
   * @param sd a <code>ScheduleDto</code> :
   * @throws Exception
   */
  public void delete(ScheduleDto sd) throws Exception {
    _sa.delete(sd);
  }

  /**
   * Describe <code>compDay</code> method : .
   * <br>w肳ꂽtwԌ̓tZoB
   *
   * @param day a <code>String</code> : {ƂȂt
   * @param offset a <code>String</code> : 
   * @param unit a <code>String</code> : Ԃ̒P Y-N ,M- ,D-
   * @return a <code>String</code> : Zoēt
   */
  public String compDay(String day, String offset, String unit) {
    if (day == null || day.length() == 0) day = DateUtil.getDate();
    if (offset == null || offset.length() == 0) offset = "0";
    int fld = Calendar.DATE;
    if ("Y".equals(unit.toUpperCase())) fld = Calendar.YEAR;
    if ("M".equals(unit.toUpperCase())) fld = Calendar.MONTH;
    int amt = Integer.parseInt(offset);
    return DateUtil.addDateTime(day, fld, amt);
  }

}
