package com.hamaf.hikyakucms.sample.schedule.ui;

import java.text.DateFormat;
import java.util.Locale;

import com.hamaf.hikyakucms.sample.schedule.dto.HolidayDto;
import com.hamaf.hikyakucms.sample.schedule.process.HolidayProcess;
import com.hamaf.hikyakucms.sample.schedule.ui.mapping.HolidayMap;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;
import com.hamaf.hikyaku.ui.StandardCheckAndUpdate;

/**
 * <p>^CgFHolidayUpdate is .</p>
 * <p>F</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2011/01/30</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class HolidayUpdate extends StandardCheckAndUpdate {

	private HolidayProcess _hp = null;

	/**
	 * Creates a new <code>HolidayUpdate.java</code> instance.
	 * <br>Default Constructor
	 */
	public HolidayUpdate() {
		_jim = new HolidayMap();
		_hp = new HolidayProcess();
	}

  private final String TAG = "message";
  private final String ERR_ET = "err_mmdd";
  private final String ERR_NF = "err_not_found";
  private final String VAL_TAG = "messageName";
	private final String MSG_OK = "updateok";
	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#checkMaster(com.hamaf.hikyaku.dataobject.CommonMessage)
	 */
	@Override
	protected CommonMessage checkMaster(CommonMessage msg) throws Exception {
		StringBuilder sb = new StringBuilder();
		sb.append(msg.getReqStr("year"));
		sb.append("/");
		sb.append(msg.getReqStr("mmdd"));
    DateFormat df = DateFormat.getDateInstance(DateFormat.MEDIUM, Locale.JAPAN);
    df.setLenient(false);
    try {
      df.parse(sb.toString());
    } catch (Exception xe) {
      msg.setErrorStatus(STATUS.WARNING);
			msg.setResMsg(MSG_OK, "0");
      MasterXmlControl mxc = MasterXmlFactory.newInstance().getMasterXml(sysId);
      msg.addMessage(mxc.getTagValue(TAG, ERR_ET, VAL_TAG));
    }
		return msg;
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
	 */
	@Override
	protected CommonMessage callControl(DetailItemsInterface dii,
			CommonMessage msg) throws Exception {
		boolean del = "1".equals(msg.getReqStr("upkbn"));
		String nm = dii.getItemValue(HolidayDto.NAME);
		dii = _hp.getDetail((HolidayDto)dii);
		if (dii.isNotFound()) {
			if (del) {
				msg.setResMsg(MSG_OK, "0");
	      msg.setErrorStatus(STATUS.WARNING);
	      MasterXmlControl mxc = MasterXmlFactory.newInstance().getMasterXml(sysId);
	      msg.addMessage(mxc.getTagValue(TAG, ERR_NF, VAL_TAG));
	      return msg;
			}
			_hp.regist((HolidayDto)dii);
			msg.setResMsg(MSG_OK, "1");
			return msg;
		}
		if (del) {
			_hp.delete((HolidayDto)dii);
		}else {
			dii.setItemValue(HolidayDto.NAME, nm);
			_hp.update((HolidayDto)dii);
		}
		msg.setResMsg(MSG_OK, "1");
		return msg;
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#newDataObj()
	 */
	@Override
	protected DetailItemsInterface newDataObj() {
		return new HolidayDto();
	}

}
