package com.hamaf.hikyakucms.sample.schedule.ui;

import com.hamaf.hikyakucms.sample.schedule.dto.ScheduleDto;
import com.hamaf.hikyakucms.sample.schedule.process.ScheduleProcess;
import com.hamaf.hikyakucms.sample.schedule.ui.mapping.ScheduleMap;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;
import com.hamaf.hikyaku.extension.MasterXmlControl;
import com.hamaf.hikyaku.extension.MasterXmlFactory;
import com.hamaf.hikyaku.ui.StandardCheckAndUpdate;

/**
 * <p>^CgFScheduleMod is .</p>
 * <p>FXPW[XVEʏ</p>
 * <br>
 *
 * <p>쌠: Copyright (c) 2010/08/24</p>
 * @author y-hamanaka
 * @version 1.0
 */
public class ScheduleMod extends StandardCheckAndUpdate {

  private ScheduleProcess _sp = null;
  private final String CHK_FLD = "ScheduleAdd";
  private final String PLGID = "schedule";

  /**
   *  Creates a new <code>ScheduleMod.java</code> instance.
   * <br>Default Constructor
   */
  public ScheduleMod() {
    _sp = new ScheduleProcess();
    _jim = new ScheduleMap();
  }

  private final String TAG = "message";
  private final String ERR_ET = "err_time";
  private final String VAL_TAG = "messageName";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#checkRelation(com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage checkRelation(CommonMessage msg) throws Exception {
    String tto = msg.getReqStr("to");
    if (tto.length() == 0) return msg;
    if (tto.compareTo(msg.getReqStr("from")) < 0) {
      msg.setErrorStatus(STATUS.WARNING);
      MasterXmlControl mxc = MasterXmlFactory.newInstance().getMasterXml(PLGID);
      msg.setResMsg("to", mxc.getTagValue(TAG, ERR_ET, VAL_TAG));
    }
    return msg;
  }

  private final String DEL = "del_flg";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#setFolder()
   */
  @Override
  protected String setFolder() {
    if ("1".equals(request.getAttribute(DEL))) return null;
    return CHK_FLD;
  }

  private final String OKFLD = "scheduleMod";
  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface, com.hamaf.hikyaku.dataobject.CommonMessage)
   */
  @Override
  protected CommonMessage callControl(DetailItemsInterface dii,
      CommonMessage msg) throws Exception {
    if ("1".equals(msg.getReqStr(DEL))) {
      _sp.delete((ScheduleDto)dii);
    } else if ("2".equals(msg.getReqStr(DEL))) {
      _sp.register((ScheduleDto)dii);
    } else {
      _sp.update((ScheduleDto)dii);
    }
    msg.setResMsg(OKFLD, "1");
    return msg;
  }

  /* (Javadoc Ȃ)
   * @see com.hamaf.hikyaku.ui.StandardCheckAndUpdate#newDataObj()
   */
  @Override
  protected DetailItemsInterface newDataObj() {
    return new ScheduleDto();
  }

}
