package com.hamaf.hikyakucms.sample.schedule.ui;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.hamaf.hikyakucms.sample.schedule.access.TargetAccess.TARGET_KBN;
import com.hamaf.hikyakucms.sample.schedule.dto.TargetDto;
import com.hamaf.hikyakucms.sample.schedule.dto.TargetSearchDto;
import com.hamaf.hikyakucms.sample.schedule.process.TargetProcess;
import com.hamaf.hikyakucms.sample.schedule.ui.mapping.TargetMap;
import com.hamaf.hikyaku.dataobject.CommonMessage;
import com.hamaf.hikyaku.dataobject.CommonMessage.STATUS;
import com.hamaf.hikyaku.dataobject.DetailItemsInterface;
import com.hamaf.hikyaku.dataobject.KeyList;
import com.hamaf.hikyaku.dataobject.RetrieveKeysInterface;
import com.hamaf.hikyaku.distribute.IllegalRetrieveDataException;
import com.hamaf.hikyaku.ui.StandardListProcess;

/**
 * <p>^CgFTargetList is .</p>
 * <p>FΏۏꗗ</p>
 * <ul>
 *   <li>"type""u"̏ꍇAΏۃ[U[̈ꗗ߂
 *   <li>"type""g"̏ꍇAΏۃO[v̈ꗗ߂
 *   <li>"type""t"̏ꍇAQƎw胆[U[̈ꗗ߂
 * </ul>
 *
 * <p>쌠: Copyright (c) 2011/02/19</p>
 * @author Yoshinori
 * @version 1.0
 *
 */
public class TargetList extends StandardListProcess {

	private TargetProcess _tp = null;
	/**
	 * Creates a new <code>TargetList.java</code> instance.
	 * <br>Default Constructor
	 */
	public TargetList() {
		_jim = new TargetMap();
		_tp = new TargetProcess();
	}

	private String _typ = null;
	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#setRetrieveVal(com.hamaf.hikyaku.dataobject.KeyList)
	 */
	@Override
	protected RetrieveKeysInterface setRetrieveVal(KeyList keyl)
			throws IllegalRetrieveDataException {
		TargetSearchDto tsd = new TargetSearchDto();
		_typ = keyl.getRetrieve("type").toLowerCase();
		if ("g".equals(_typ)) {
			tsd.setRetrieveValue(TargetSearchDto.USER_ID, getUserID());
			tsd.setRetrieveValue(TargetSearchDto.KUBUN, TARGET_KBN.GROUP.getValue());
		} else if ("u".equals(_typ)) {
			tsd.setRetrieveValue(TargetSearchDto.USER_ID, getUserID());
			tsd.setRetrieveValue(TargetSearchDto.KUBUN, TARGET_KBN.USER.getValue());
		} else if ("t".equals(_typ)) {
			tsd.setRetrieveValue(TargetSearchDto.KUBUN, TARGET_KBN.USER.getValue());
			tsd.setRetrieveValue(TargetSearchDto.TARGET_ID, getUserID());
		}
		return tsd;
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#findKeys(com.hamaf.hikyaku.dataobject.RetrieveKeysInterface)
	 */
	@Override
	protected RetrieveKeysInterface findKeys(RetrieveKeysInterface rki)
			throws Exception {
		return _tp.find((TargetSearchDto)rki);
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#newDataObj()
	 */
	@Override
	protected DetailItemsInterface newDataObj() {
		return new TargetDto();
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#callControl(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
	 */
	@Override
	protected DetailItemsInterface callControl(DetailItemsInterface dii)
			throws Exception {
		return _tp.findByPrimaryKey((TargetDto)dii);
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.StandardListProcess#checkDelete(com.hamaf.hikyaku.dataobject.DetailItemsInterface)
	 */
	@Override
	protected String[] checkDelete(DetailItemsInterface dii) {
		return null;
	}

	/* ( Javadoc)
	 * @see com.hamaf.hikyaku.ui.ProcessBase#finish(com.hamaf.hikyaku.dataobject.CommonMessage)
	 */
	@Override
	public CommonMessage finish(CommonMessage msg) {
		if (!msg.getErrorStatus().equals(STATUS.NORMAL) && "g".equals(_typ)) {
			try {
				List<List<String>> grps = _tp.getUser2Group(getUserID());
				for (List<String> uinf : grps) {
	        Map<String, String> dt = new HashMap<String, String>();
					dt.put("uid", getUserID());
					dt.put("kubun", TARGET_KBN.GROUP.getValue());
					dt.put("target", uinf.get(0));
					dt.put("seq", uinf.get(2));
					dt.put("name", uinf.get(1));
					msg.addResList(dt);
				}
			}
			catch (Exception ex) {
				ex.printStackTrace();
			}
		}
		return super.finish(msg);
	}

}
